/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the HttpStorageRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &HttpStorageRequest{}

// HttpStorageRequest struct for HttpStorageRequest
type HttpStorageRequest struct {
	Label *string `json:"label,omitempty"`
	Type  *string `json:"type,omitempty"`
}

// NewHttpStorageRequest instantiates a new HttpStorageRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewHttpStorageRequest() *HttpStorageRequest {
	this := HttpStorageRequest{}
	return &this
}

// NewHttpStorageRequestWithDefaults instantiates a new HttpStorageRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewHttpStorageRequestWithDefaults() *HttpStorageRequest {
	this := HttpStorageRequest{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *HttpStorageRequest) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HttpStorageRequest) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *HttpStorageRequest) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *HttpStorageRequest) SetLabel(v string) {
	o.Label = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *HttpStorageRequest) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HttpStorageRequest) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *HttpStorageRequest) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *HttpStorageRequest) SetType(v string) {
	o.Type = &v
}

func (o HttpStorageRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o HttpStorageRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	return toSerialize, nil
}

type NullableHttpStorageRequest struct {
	value *HttpStorageRequest
	isSet bool
}

func (v NullableHttpStorageRequest) Get() *HttpStorageRequest {
	return v.value
}

func (v *NullableHttpStorageRequest) Set(val *HttpStorageRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableHttpStorageRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableHttpStorageRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableHttpStorageRequest(val *HttpStorageRequest) *NullableHttpStorageRequest {
	return &NullableHttpStorageRequest{value: val, isSet: true}
}

func (v NullableHttpStorageRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableHttpStorageRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
